#
# Std-Template for Multiprog -ST generation
# By Robbert van Leeuwen 2007
# 



BEGIN@STATELIST
 
END@STATELIST

BEGIN@DATA
(***************************************************************************\
*
*
*  WARNING : THIS FILE IS GENERATED BY @USER AT @DATE @TIME
*  WITH STD (c) FROM FILE : @SRC
*
* (c) Copyright 
*
* $Workfile:   @FNAME  $
*
* $Module: @MODUP
*
*
\***************************************************************************)

FOR _for:=0 TO 0 DO (* This dummy statement is to allow the ST 'exit' statement *)


UnitReady:=@UNITREADY OR NOT(UnitEnable) ;

@USRDATA

UnitIdle:=OkToStop AND NOT UnitRun;

IF UnitIdle OR NOT UnitEnable THEN
  EXIT;
END_IF;

IF PrevStateNr@FNAME<>StateNr@FNAME THEN
  (* Set your breakpoint beneath to track state changes*)
  PrevStateNr@FNAME:=StateNr@FNAME;
END_IF;

CASE StateNr@FNAME OF
@INSERT_EXEC_BODY
END_CASE;

END_FOR; (*end dummy statement to allow ST 'exit' statement*)

END@DATA


BEGIN@UNITREADY
END@UNITREADY

BEGIN@IB
END@IB


BEGIN.STD


  &FUNC TabIns(level)
  [t]
  {
    t=copy("\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t",0,level)
  }
  RETURN(t)

  &FUNC GetNormalTrans(level)
  [s,stateName,sNum]
  {
    s=""
    
    StdError((ctrans()=="")&(NxtStatCnt()<>1)&(cstate()<>"T")&(cstate()<>nstate()),"State ["+cstate()+"] can not contain more trans by default trans")


    IF(cstate()<>nstate())
    {
      
      stateName=sr(nstate(),">","")

      sNum=GetItem("@"+stateName+"=",stateList)
      StdError(sNum=="","Invalid transition to state ["+stateName+"]")

      s=s+TabIns(level)+"OkToStop:="+IFQ(copy(stateName,0,1)=="i","TRUE","FALSE")+";\n"

      s=s+TabIns(level)+"StateNr@FNAME:="+sNum+";\n"
      s=s+TabIns(level)+"EXIT;\n"
    }
  }
  return(s)


  &PROC CollectErrorInfo()
  [pos,AddErrMsg]
  {
    if(find(caction(),"Err_")==0)
    {
       pos=find(caction(),":")
       if(pos<>-1)
       {
          AddErrMsg=Copy(caction(),0,pos)
          IF(find(UnitReady,AddErrMsg)<0)
          {
            IF(UnitReady<>"")
            {
              UnitReady=UnitReady+" AND"
            }
     
            UnitReady=UnitReady+" NOT "+AddErrMsg
          }
        }
     }
  }
 #return(1)

  &FUNC GetAction(level)
  [s,t]
  {
    t=TabIns(level)
    s=""
    ForEach:Action
    {
      IF(caction()<>"")
        BEGIN
          CollectErrorInfo()
          s=s+t+caction()+";\n"
        END
    }
  }
  return(s)

  &FUNC GetCondition(level)
  [s,t]
  {
    s=""
    if(alltrim(ctrans())<>"")
    {
      t=TabIns(level)
      s=s+t+"IF( "+SR(SR(ctrans(),"\n",""),"\r"," ")+" ) THEN\n"
    }
  }
  return(s)

  &FUNC Transitorial(level)
  [s,action]
  {

    if(cstate()=="T")
    {
      StdError(!ContainsDefTrans(),"Transitorial should contain one default transition "+cthread())
    }

    s=GetCondition(level)

    IF(ctrans()<>"")
    {
       level=level+1
    }

    action=GetAction(level)
    s=s+action
    if(nstate()=="T")
    {
      PushStdData()
      ZoomState()
      ForEach:Trans
      {
        s=s+Transitorial(level)
      }
      PopStdData() 
    }
    else
    {
      s=s+GetNormalTrans(level)
    }

    IF(ctrans()<>"") 
    {
      s=s+TabIns(level-1)+"END_IF;\n"
    }
  }
  return(s)


  &FUNC ParseTransitorial(level)
  [s]
  {
    s=Transitorial(level)
  }
  return(s)




  # Read module name from STD info block
 
  status("Combining STD data ")

 

  ForEach:Thread
  {
      #Reset variables for combining data
     # IB=""
      rstate()
      states=""
      state_names=" "
      first=TRUE

      stateList=""
      i=0
      ForEach:State
      {
        IF((cstate()<>"T") &(copy(cstate(),0,1)<>">"))
        {
          stateList=stateList+"@"+cstate()+"="+itos(i)+"\r"
          i=i+1
        }
      }

      ForEach:State
      {
        IF((cstate()<>"T") &(copy(cstate(),0,1)<>">"))
        {
          # If not first state of thread then put a "," and a CR/LF
          IF(!first) 
          {
              states=states+",\n  "
              state_names=state_names+",\n "
          }
          first=FALSE
          state_names=state_names+"\""+cstate()+"\""
          state=sr(uscore(cstate()),"#","")
          states=states+state
        
          IB=IB+"\f\n"
          IB=IB+"\t(***********************************************\n"
          IB=IB+"\t *\n"
          IB=IB+"\t * State       :"+state+"("+GetItem("@"+state+"=",stateList)+")\n"
          IB=IB+"\t * Description :"+Dstate()+"\n"
          IB=IB+"\t * Prev states :"+sr(uscore(PrvStateList()),"#","")+"\n"
          IB=IB+"\t * Next states :"+sr(uscore(NxtStateList()),"#","")+"\n"
          IB=IB+"\t *\n"
          IB=IB+"\t/**********************************************)\n"
          IB=IB+"\t"+GetItem("@"+state+"=",stateList)+": (*"+state+"*)\n"
          StdError( (copy(cstate(),0,1)<>"i")& (copy(cstate(),0,1)<>"b"),"Invalid statename should be i.. or b..")

          
          ForEach:Trans
          {
            IB=IB+ParseTransitorial(2)
          }
          
       }
      }

      RunError(states=="","Please select a state in your STD\nWith a 'First state of thread @EXEC'")
  

      s=data
      s=sr(s,"@INSERT_EXEC_BODY",IB)
      s=sr(s,"@USRDATA",GetUsrData())
      s=sr(s,"@FNAME",cthread())
      s=sr(s,"@MODUP",cthread())
      s=sr(s,"@MODULE",cthread())
      s=sr(s,"@USER",GetUser())
      s=sr(s,"@DATE",date())
      s=sr(s,"@TIME",time())
      s=sr(s,"@SRC",CurPath()+CurFile()+".STD")
      s=sr(s,"\n","\r\n")

      IF(UnitReady=="")
      { 
Message("huh")
         UnitReady="TRUE"
      }
      s=sr(s,"@UNITREADY",UnitReady)

      fname=CurPath()+cthread()+".ST"
      writefile(fname,s)
      status("File :",fname," ready...")
      ToClipboard(s)

  }
END.STD







